<?php

class Model_Helper_StudentBuilder extends Model_Helper_Builder
{
    public function create() {
        $this->data += [
            'SecondName' => ''
        ];

        $required = [
            'LastName', 'SecondName', 'FirstName'
        ];

        if (array_diff($required, array_keys($this->data)))
            throw new InvalidArgumentException('Not enough arguments');

        return new Model_Student($this->data, false);
    }

    public function & externalID($string) {
        $string = trim($string);
        if (!$string)
            throw new InvalidArgumentException('externalID can\'t be empty');
        $this->data['ExternalID'] = $string;
        return $this;
    }

    public function & lastName($string) {
        $string = trim($string);  # todo: remove empty symbols
        if (!$string)
            throw new InvalidArgumentException('Last name can\'t be empty');
        $this->data['LastName'] = $string;
        return $this;
    }

    public function & firstName($string) {
        $string = trim($string);
        if (!$string)
            throw new InvalidArgumentException('First name can\'t be empty');
        $this->data['FirstName'] = $string;
        return $this;
    }

    public function & secondName($string) {
        $this->data['SecondName'] = trim($string);
        return $this;
    }

    public function & grade($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Grade id is incorrect');
        $this->data['GradeID'] = (int) $id;
        return $this;
    }

    public function & group($num) {
        if (!is_numeric($num) || $num <= 0)
            throw new InvalidArgumentException('GroupNum id is incorrect');
        $this->data['GroupNum'] = (int) $num;
        return $this;
    }

    public function & faculty($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Faculty id is incorrect');
        $this->data['FacultyID'] = (int) $id;
        return $this;
    }

    public function & semester($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Semester id is incorrect');
        $this->data['SemesterID'] = (int) $id;
        return $this;
    }
}
