<?php defined('SYSPATH') || die('No direct script access.');

class Model_Support extends Model
{
    // return request ID
    public static function createRequest($accountID, $title, $description, $hasImg = false) {
        $sql = 'SELECT `CreateRequest`(:account, :title, :description, :hasImg) AS Num';
        return DB::query(Database::SELECT, $sql)
            ->param(':account', (int) $accountID)
            ->param(':description', $description)
            ->param(':title', $title)
            ->param(':hasImg', $hasImg)
            ->execute()->get('Num');
    }

    // returns status code
    public static function updateRequest($requestID, $title, $description) {
        $sql = 'SELECT `UpdateRequest`(:requestID, :title, :description) AS Num';
        return DB::query(Database::SELECT, $sql)
            ->param(':requestID', (int) $requestID)
            ->param(':description', $description)
            ->param(':title', $title)
            ->execute()->get('Num');
    }

    public static function getRequests($userID, $offset = 0, $count = 1000, $statusFilter = 'all') {
        $sql = 'CALL `GetRequests`(:offset, :count, :account, :filter)';
        return DB::query(Database::SELECT, $sql)
            ->param(':account', $userID)
            ->param(':offset', $offset)
            ->param(':count', $count)
            ->param(':filter', $statusFilter)
            ->execute()->as_array();
    }

    public static function getNumberOfRequests($statusFilter) {
        $sql = 'CALL `RequestsNum` (:filter)';
        return DB::query(Database::SELECT, $sql)
            ->param(':filter', $statusFilter)
            ->execute()->get('Num');
    }

    public static function setStatus($requestID, $status) {
        $sql = 'SELECT `SetRequestStatus`(:requestID, :status) AS Num';
        return DB::query(Database::SELECT, $sql)
            ->param(':requestID', (int) $requestID)
            ->param(':status', $status)
            ->execute()->get('Num');
    }
}
